#ifndef _COMMUNICATIONH_
#define _COMMUNICATIONH_

#include "ljtypes.h"
 
#define nowhere       0x00  
#define posX          0x01  
#define negX          0x02  
#define posY          0x04  
#define negY          0x08  
#define posZ          0x10  
#define negZ          0x20  
#define to_be_removed 0x40  
#define end_of_list   0x80  

extern long long pos_tag[3];   
extern long long neg_tag[3];   
extern long long send_tag[13]; 
extern int n_send_tag[4];       

long long reverseTag(long long tag); 
 
void IdVector_pack    (long long tag, int  n_src, struct IdVector src[], int* n_dst, struct IdVector dst[]);
void IdVector_move    (long long tag, int* n_src, struct IdVector src[], int* n_dst, struct IdVector dst[]); 
void IdVector_tag_move(long long tag, int* n_src, struct IdVector src[], int* n_dst, struct IdVector dst[]); 
void IdVector_prune   (int* n, struct IdVector from[]);
void IdVector_exchange(int* n_in, struct IdVector in[], int src, int n_out, struct IdVector out[], int dst,  
                       int tag, int n_in_max, MPI_Comm comm); 
 
void Atom_pack    (long long tag, int  n_src, struct Atom src[], int* n_dst, struct IdVector dst[]);
void Atom_move    (long long tag, int* n_src, struct Atom src[], int* n_dst, struct Atom dst[]); 
void Atom_tag_move(long long tag, int* n_src, struct Atom src[], int* n_dst, struct Atom dst[]);
void Atom_prune   (int* n, struct Atom from[]);
void Atom_exchange(int* n_in, struct Atom in[], int src, int n_out, struct Atom out[], int dst,  
                   int tag, int n_in_max, MPI_Comm comm); 

#endif

